using Adaptation.Shared;
using Adaptation.Shared.Methods;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Diagnostics;
using System.IO;
using System.Reflection;

namespace Adaptation._Tests.Extract.Staging.v2_39_0;

[TestClass]
public class CDE3
{

#pragma warning disable CA2254
#pragma warning disable IDE0060

    private static CreateSelfDescription.Staging.v2_39_0.CDE3 _CDE3;

    [ClassInitialize]
    public static void ClassInitialize(TestContext testContext)
    {
        CreateSelfDescription.Staging.v2_39_0.CDE3.ClassInitialize(testContext);
        _CDE3 = CreateSelfDescription.Staging.v2_39_0.CDE3.EAFLoggingUnitTesting;
    }

    [TestMethod]
    public void Staging__v2_39_0__CDE3__RsM() => _CDE3.Staging__v2_39_0__CDE3__RsM();

    [TestMethod]
    public void Staging__v2_39_0__CDE3__RsM643047560320000000__Normal()
    {
        DateTime dateTime;
        string check = "*.RsM";
        _CDE3.Staging__v2_39_0__CDE3__RsM();
        MethodBase methodBase = new StackFrame().GetMethod();
        string[] variables = _CDE3.AdaptationTesting.GetVariables(methodBase, check);
        IFileRead fileRead = _CDE3.AdaptationTesting.Get(methodBase, sourceFileLocation: variables[2], sourceFileFilter: variables[3], useCyclicalForDescription: false);
        Logistics logistics = new(fileRead);
        string extractResultItem1 = Shared.AdaptationTesting.ReExtractCompareUpdatePassDirectory(variables, fileRead, logistics);
        dateTime = FileHandlers.RsM.ProcessData.GetDateTime(logistics, string.Empty);
        Assert.IsTrue(dateTime == logistics.DateTimeFromSequence);
        dateTime = FileHandlers.RsM.ProcessData.GetDateTime(logistics, "00:13 09/27/38");
        Assert.IsTrue(dateTime == logistics.DateTimeFromSequence);
        string logBody = @"
RUN	[59-478796-3978.1]
Recipe	LSL_6in \ WACKER2	RESISTIVITY SPEC
EQUIP#	ResMap	Engineer	Engineer
LotID	LotID	D.L.RATIO	0.9950
OPERATOR	Operator	TEMP	19.4	00:13 09/27/38
AutoOptimizeGain = YES	AutoProbeHeightSet = NO
DataReject > 3.0Sigma
0	C:\4p_NT\LSL_6in.prj\WACKER2.rcp\8927A117.RsM	00:13 09/27/38
pt#	R	Th	Rs[Ohm/sq@T]	Merit
1	65.0	-44.5	577.7672	77.79
2	32.5	-44.5	572.4527	102.7
3	0.0	0.5	581.8071	108.0
4	-32.5	-44.5	576.9838	93.04
5	-65.0	-44.5	577.0866	69.79
Avg =	577.2195	0.58%	SEMI Radial= 0.81%
            ";
        bool logBodyCheck = logBody.Trim() == extractResultItem1.Trim();
        if (!logBodyCheck)
        {
            _ = Process.Start("explorer.exe", variables[5]);
            File.WriteAllText(Path.Combine(variables[5], $"{Path.GetFileName(variables[5])}.log"), extractResultItem1);
        }
        Assert.IsTrue(logBodyCheck, "Log Body doesn't match!");
    }

}